//
//  Small.m
//  bigAndSmall
//
//  Created by 栗子 on 2017/7/12.
//  Copyright © 2017年 栗子. All rights reserved.
//

#import "Small.h"


@interface Small ()<CAAnimationDelegate>

@property(nonatomic,strong)UIView *endVIew;
@end

@implementation Small


-(instancetype)initWithFrame:(CGRect)frame endPathViewFrame:(CGRect)endViewFrame{
    if (self=[super initWithFrame:frame]) {
        [CommonMethods layerGradientLayer:self];

        self.endVIew=[[UIView alloc]initWithFrame:endViewFrame];
        self.endVIew.backgroundColor=[UIColor clearColor];
        [self addSubview:self.endVIew];

        CGRect rect = CGRectInset(self.endVIew.frame, -1000, -1000);
        
        CGPathRef startPath = CGPathCreateWithEllipseInRect(rect, NULL);
        CGPathRef endPath   = CGPathCreateWithEllipseInRect(self.endVIew.frame, NULL);
        
        CAShapeLayer *maskLayer = [[CAShapeLayer alloc] init];
        maskLayer.path = startPath;
        
        self.layer.mask = maskLayer;
        
        CABasicAnimation *pingAnimation = [CABasicAnimation animationWithKeyPath:@"path"];
        
        pingAnimation.fromValue = (__bridge id)(endPath);
        pingAnimation.toValue   = (__bridge id)(startPath);
        pingAnimation.duration  = 1;
        pingAnimation.delegate = self;
        [pingAnimation setValue:@"animate1" forKey:@"animate1"];
        pingAnimation.timingFunction = [CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionEaseInEaseOut];
        
        [maskLayer addAnimation:pingAnimation forKey:@"pingInvert1"];
        
        CGPathRelease(startPath);
        CGPathRelease(endPath);

    }
    return self;
}
- (void)animationDidStop:(CAAnimation *)anim finished:(BOOL)flag
{
    if ([self.delegate respondsToSelector:@selector(jumpController)]) {
    [self.delegate jumpController];
}

    
     if([[anim valueForKey:@"animate2"] isEqualToString:@"animate2"])
    {
        [self removeFromSuperview];
        
        
    }

}


@end
